unit ICCAPI;

interface

	uses
{$ifc undefined THINK_Pascal}
		Types, Files, 
{$endc}
		Components, ICTypes;

	const
		internetConfigurationComponentType = 'PREF';				(* the component type *)
		internetConfigurationComponentSubType = 'ICAp';			(* the component subtype *)
		internetConfigurationComponentInterfaceVersion = 0;	(* current version number *)

	function ICCStart (var inst: ComponentInstance; creator: OSType): ICError;
	(* checks for the presence of the Component Manager and the Internet Configuration component *)
	(* returns badComponentInstance if it can't find either*)
	(* inst is either nil or a valid component instance *)
	(* this routine lets you access the component based implementation with only minimal*)
	(* yucky glue *)
	function ICCStop (inst: ComponentInstance): ICError;
	(* shut down the component *)

	function ICCFindConfigFile (inst: ComponentInstance; count: integer; folders: ICDirSpecArrayPtr): ICError;
	inline
		$2F3C, $06, $2, $7000, $A82A;
	function ICCSpecifyConfigFile (inst: ComponentInstance; config: FSSpec): ICError;
	inline
		$2F3C, $04, $3, $7000, $A82A;

	function ICCGetSeed (inst: ComponentInstance; var seed: longint): ICError;
	inline
		$2F3C, $04, $4, $7000, $A82A;
	function ICCGetPerm (inst: ComponentInstance; var perm: ICPerm): ICError;
	inline
		$2F3C, $04, $D, $7000, $A82A;

	function ICCBegin (inst: ComponentInstance; perm: ICPerm): ICError;
	inline
		$2F3C, $02, $5, $7000, $A82A;
	function ICCGetPref (inst: ComponentInstance; key: Str255; var attr: ICAttr; buf: Ptr; var size: longint): ICError;
	inline
		$2F3C, $10, $6, $7000, $A82A;
	function ICCSetPref (inst: ComponentInstance; key: Str255; attr: ICAttr; buf: Ptr; size: longint): ICError;
	inline
		$2F3C, $10, $7, $7000, $A82A;
	function ICCCountPref (inst: ComponentInstance; var count: longint): ICError;
	inline
		$2F3C, $04, $8, $7000, $A82A;
	function ICCGetIndPref (inst: ComponentInstance; n: longint; var key: Str255): ICError;
	inline
		$2F3C, $08, $9, $7000, $A82A;
	function ICCDeletePref (inst: ComponentInstance; key: Str255): ICError;
	inline
		$2F3C, $04, $C, $7000, $A82A;
	function ICCEnd (inst: ComponentInstance): ICError;
	inline
		$2F3C, $00, $A, $7000, $A82A;

	function ICCDefaultFileName (inst: ComponentInstance; var name: Str63): ICError;
	inline
		$2F3C, $04, $B, $7000, $A82A;

implementation
end. (* ICCAPI *)
