/* ASTPrintExpr.h */

#ifndef Included_ASTPrintExpr_h
#define Included_ASTPrintExpr_h

/* ASTPrintExpr module depends on */
/* MiscInfo.h */
/* Audit */
/* Debug */
/* Definitions */
/* TrashTracker */
/* Memory */
/* ASTExpression */
/* PcodeObject */
/* CompilerRoot */
/* PromotableTypeCheck */

#include "PcodeObject.h"
#include "CompilerRoot.h"

struct ASTPrintExprRec;
typedef struct ASTPrintExprRec ASTPrintExprRec;

/* all memory allocated in this module is through TrashTracker */

/* forwards */
struct TrashTrackRec;
struct ASTExpressionRec;

/* create a new AST expression print */
ASTPrintExprRec*		NewPrintExpr(struct ASTExpressionRec* Expression,
											struct TrashTrackRec* TrashTracker, long LineNumber);

/* type check the expr print node.  this returns eCompileNoError if */
/* everything is ok, and the appropriate type in *ResultingDataType. */
CompileErrors				TypeCheckPrintExpr(DataTypes* ResultingDataType,
											ASTPrintExprRec* PrintExpr, long* ErrorLineNumber,
											struct TrashTrackRec* TrashTracker);

/* generate code for an expr print.  returns True if successful, or False if it fails. */
MyBoolean						CodeGenPrintExpr(struct PcodeRec* FuncCode,
											long* StackDepthParam, ASTPrintExprRec* PrintExpr);

#endif
