/* FilterButterworthBandpass.h */

#ifndef Included_FilterButterworthBandpass_h
#define Included_FilterButterworthBandpass_h

/* FilterButterworthBandpass module depends on */
/* MiscInfo.h */
/* Audit */
/* Debug */
/* Definitions */
/* Memory */
/* FloatingPoint */

struct ButterworthBandpassRec;
typedef struct ButterworthBandpassRec ButterworthBandpassRec;

/* flush free list */
void											FlushCachedButterworthBandpassStuff(void);

/* create a new filter record */
ButterworthBandpassRec*		NewButterworthBandpass(void);

/* dispose filter record */
void											DisposeButterworthBandpass(ButterworthBandpassRec* Filter);

/* adjust filter coefficients */
void											SetButterworthBandpassCoefficients(ButterworthBandpassRec* Filter,
														float Cutoff, float Bandwidth, long SamplingRate);

/* apply filter to a sample value */
float											ApplyButterworthBandpass(ButterworthBandpassRec* Filter, float Xin);

#endif
