/* FilterButterworthHighpass.h */

#ifndef Included_FilterButterworthHighpass_h
#define Included_FilterButterworthHighpass_h

/* FilterButterworthHighpass module depends on */
/* MiscInfo.h */
/* Audit */
/* Debug */
/* Definitions */
/* Memory */
/* FloatingPoint */

struct ButterworthHighpassRec;
typedef struct ButterworthHighpassRec ButterworthHighpassRec;

/* flush free list */
void											FlushCachedButterworthHighpassStuff(void);

/* create a new filter record */
ButterworthHighpassRec*		NewButterworthHighpass(void);

/* dispose filter record */
void											DisposeButterworthHighpass(ButterworthHighpassRec* Filter);

/* adjust filter coefficients */
void											SetButterworthHighpassCoefficients(ButterworthHighpassRec* Filter,
														float Cutoff, long SamplingRate);

/* apply filter to a sample value */
float											ApplyButterworthHighpass(ButterworthHighpassRec* Filter, float Xin);

#endif
