/* FilterSecondOrderZero.h */

#ifndef Included_FilterSecondOrderZero_h
#define Included_FilterSecondOrderZero_h

/* FilterSecondOrderZero module depends on */
/* MiscInfo.h */
/* Audit */
/* Debug */
/* Definitions */
/* Memory */
/* FloatingPoint */
/* FilterSpec */

#include "FilterSpec.h"

struct SecondOrderZeroRec;
typedef struct SecondOrderZeroRec SecondOrderZeroRec;

/* flush free list */
void											FlushCachedSecondOrderZeroStuff(void);

/* create a new filter record */
SecondOrderZeroRec*				NewSecondOrderZero(void);

/* dispose filter record */
void											DisposeSecondOrderZero(SecondOrderZeroRec* Filter);

/* adjust filter coefficients */
void											SetSecondOrderZeroCoefficients(SecondOrderZeroRec* Filter,
														float Cutoff, float Bandwidth, FilterScalings Scaling,
														long SamplingRate);

/* apply filter to a sample value */
float											ApplySecondOrderZero(SecondOrderZeroRec* Filter, float Xin);

#endif
