/* WaveIndexUtility.h */

#ifndef Included_WaveIndexUtility_h
#define Included_WaveIndexUtility_h

/* WaveIndexUtility module depends on */
/* MiscInfo.h */
/* Audit */
/* Debug */
/* Definitions */
/* FastFixedPoint */
/* 64BitMath */
/* Memory */

#include "FastFixedPoint.h"

/* perform wavetable indirection on an 8 bit wave */
/* returns a value between MAX16BIT and MIN16BIT */
signed long					WaveTable8Bit(float Phase, FastFixedType TableIndex,
											long NumTables, long Frames, signed char** Matrix);

/* perform wavetable indirection on a 16 bit wave */
/* returns a value between MAX16BIT and MIN16BIT */
signed long					WaveTable16Bit(float Phase, FastFixedType TableIndex,
											long NumTables, long Frames, signed short** Matrix);

#endif
