*********************************************************************************
*SPRITE 1.00					*
*VERY SIMPLE SPRITE ROUTINES FOR MAC 			*
*LIGHTSOFT 111094				*
*AUTHOR:	SB/RZP  LIGHTSOFT '94			*
*APPOLOGIES:	SORRY IF THIS IS A BIT MESSY, BUT IT WAS DONE IN 8 HOURS (SB)	*
*COPYRIGHT:	LIGHTSOFT 94 - MAY BE USED AS BASIS FOR OTHER GAMES/APP SO      *
*	LONG AS REGISTRATION FEE IS PAID.		*
*FUNCTIONS:					*
*	HANDLES UPTO MAXSPRITE SPRITES USING SIMPLE CALLS 	*
*0.	INIT(cook table) - INITS LBM AND VBL ROUTINE		*
*1.	LOAD_SHAPE (N,RN) - LOADS A icl8(RN) AS A SHAPE N	*
*2.	KILL_SPRITE (N) - REMOVES SPRITE N (1-32) FROM SCREEN	*
*3.	SET_SPRITE (N,S) - ASSIGNS SHAPE S TO SPRITE N		*
*4.	DO_SPRITES(LIST) - DOES ALL THE SPRITE PROCESSING IN ONE SWOOP	*
*	NEEDS A LIST IN A0 OF SPRITES TO REDRAW. WAITS FOR VBL, REDRAWS *
*	OLD BACGROUNDS, GETS NEW BACKGROUNDS AND PRINTS THE SPRITES     *
*	IN THEIR NEW LOCATIONS.			*
*5.	SPRITE_TERM - NO PARAMS - TERMINATES THE SPRITE ROUTINES ON     *
*	SHUTDOWN **MUST BE CALLED BEFORE APP EXITS ELSE VBL ROUTINE     *
*	WIL LSTILL BE ACTIVE!			*
*					*
*					*
*RETURNS - 	SOME FUNCTIONS RETURN EITHER 0 (OK) OR -VE ERROR		*
*ASSUMPTIONS:	SCREEN BASE ADDRESS AND SIZE NEVER CHANGES		*
*	GDC LBM PRESENT				*
*PARAMETER PASSING - POINTERS - A0 UPWARDS.			*
*	     CONSTANTS - D0 UPWARDS			*
*RETURN CODE ALWAYS IN D0, AND ALWAYS LAST INSTRUCTION IN ROUTINE, SO NO CMP	*
*NEEDED IN CALLER				*
*RESTRICTIONS:	MUST BE POS INDEPENDANT			*
*********************************************************************************
MAX_SHAPES:	EQU	128	MAXIMUM NUMBER OF ICL8'S LOADED
MAX_SPRITES:	EQU	16	MAX NUMBER OF SPRITES
*********SPRITE_INIT NEEDS A0->COOK TABLE ADDR
** D0=MAX X.W, D1=MAX Y.W,
*********INITIALISES SPRITE VARS (FOR 32 (32*32) SPRITES)
*********RETURNS D0=O=OK
*********	 D0=-1=COULDNT ALLOC MEMORY
INIT:	MOVE.L	A6,-(SP)	WE USE A6 FOR ALL OUR VARS
	LEA	SPRITE_VARS(PC),A6

**GET MEM FOR SHAPES
	MOVE.L	A0,COOK_TAB_ADDR(A6)	SCREEN Y ADDRESSES
	MOVE.W	D0,MAX_X(A6)	MAX X OF SCREEN
	MOVE.W	D1,MAX_Y(A6)	MAX Y OF SCREEN
	MOVE.L	(A0),SCRN_BASE_ADDR(A6)	SAVE BASE ADDRESS
	MOVE.L	#MAX_SHAPES*32*32,D0	MEM WANTED FOR SHAPES, EACH 32*32
	DC.W	NEWPTR	GET MEM FOR SPRITE
	MOVE.L	A0,D1
	BEQ	OUT_OF_RANGE	NO MEMORY!
	BMI	OUT_OF_RANGE
	MOVE.L	D1,SHAPE_MEM(A6)
	MOVE.L	#MAX_SHAPES*32*32,SHAPE_MEM_SIZE(A6)
**GET MEM FOR BACKGROUND
	MOVE.L	#MAX_SPRITES*(32^2)+(20*1024),D0	20K EXTRA JUST IN CASE I GET IT SLIGHTLY :-) WRONG
	DC.W	NEWPTR	GET MEM FOR BACKGROUND
	MOVE.L	A0,D1
	BEQ	OUT_OF_RANGE	RETURN -1
	BMI	OUT_OF_RANGE
	MOVE.L	D1,BACK_MEM(A6)	SAVE ADDRESS OF BACK-MEM
	MOVE.L	#MAX_SPRITES*32^2,D0
	MOVE.L	D0,BACK_MEM_SIZE(A6)
**SET BACK MEM TO -1'S
	MOVE.L	D1,A0
	LSR.L	#2,D0	SET COORDS IN BACK MEM TO -1,-1
CLR_BACK_MEM:	MOVE.L	#-1,(A0)+	
	DBRA	D0,CLR_BACK_MEM
		
	LEA	SPRITE_DATA(PC),A0	CLEAR SPRITE DATA
	MOVE.L	#MAX_SPRITES/4,D0	COUNTER
CLEAR_SN:	CLR.L	(A0)+
	CLR.L	(A0)+	EACH SPRITE IS 4 WORDS
	DBRA	D0,CLEAR_SN	CLEAR SPRITE
**INSTALL OUR VBL ROUTINE
	bsr	install_waitforscreenvbl

	MOVEQ	#0,D0
	MOVE.L	(SP)+,A6	RESTORE A6

	RTS
	DC.B	"INIT    "	MACSBUG LABEL
	EVEN
*****SPRITE_TERM - NO PARAMETERS
SPRITE_TERM:	bsr	remove_waitforscreenvbl
	RTS
*****************************LOAD SHAPE N,RN********************************************
**N=SHAPE NUMBER
**RN=CICN RESOURCE NUMBER
**RETURNS D0=0 = OK, -1 = N OUT OF RANGE, -2=PICT NOT FOUND
**LOADED!
**DESTROYS A0-A2/D0-D2
**MODIFIED FOR V2.1 RELEASE TO USE GETRESOURCE
LOAD_SHAPE:	MOVE.L	A6,-(SP)
	LEA	SPRITE_VARS(PC),A6

	TST.W	D0
	BLE.S	OUT_OF_RANGE	VALID RANGE 1 to max_shapes
	CMPI.W	#MAX_SHAPES,D0
	BGT.S	OUT_OF_RANGE
	MOVE.W	D0,SCRATCH_1(A6)	SAVE SPRITE NUMBER
	CLR.L	-(SP)
	MOVE.L	#"icl8",-(SP)
	MOVE.W	D1,-(SP)	RESOURCE NUMBER
	DC.W	GETRESOURCE
	MOVE.L	(SP)+,D0
	BEQ.S	PICT_NOT_FOUND
	MOVE.L	D0,PICT_HANDLE(A6)	SAVE HANDLE	
;	MOVE.L	D0,-(SP)	HANDLE ON STACK
;	MOVE.L	#0,-(SP)	OFFSET
;	PEA	SPRITE_BUFFER(PC),-(SP)	WHERE ITS GOING
;	MOVE.L	#1024,-(SP)	BYTE COUNT
;	MOVE.W	#$7001,D0	READ PARTIAL
;	DC.W	$A822

**POSITION SHAPE_MEM FOR SPRITE DATA
	MOVE.W	SCRATCH_1(A6),D7
	EXT.L	D7
	MOVE.L	SHAPE_MEM(A6),A1
	LSL.L	#8,D7
	LSL.L	#2,D7	FREE SLOT POS*1024
	ADD.L	D7,A1	POINT TO FREE SLOT
;	LEA	SPRITE_BUFFER(PC),A0
	move.l	pict_handle(a6),a0
	move.l	(a0),a0
	MOVE.L	#(1024/4)-1,D1	COUNTER
**COPY DATA TO SLOT
COPY_SPRITE_PHYS:
	MOVE.L	(A0)+,(A1)+
	DBRA	D1,COPY_SPRITE_PHYS	
**CLEAR MEMORY
*	MOVE.L	PICT_HANDLE(A6),-(SP)
*	DC.W	$A9a3	RELEASERESOURCE
	
	MOVE.L	(SP)+,A6
	CLR.L	D0	RETURN AOK
	RTS
	
	
PICT_NOT_FOUND:	MOVE.L	(SP)+,A6
	MOVEQ	#-2,D0	PICT NOT FOUND
	RTS
	
OUT_OF_RANGE:	MOVE.L	(SP)+,A6
	MOVEQ	#-1,D0	BAD SPRITE NUMBER
	RTS
	DC.B	"LOAD_SHA"
	EVEN

************************************
**SET_SPRITE NUMBER,SHAPE D0,D1 - NO ERROR CHECKING!
**DESTRYS A1
SET_SPRITE:	LEA	SPRITE_DATA(PC),A1
	SUBQ.L	#1,D0	MAKE REAL
	EXT.L	D0
	MOVE.W	D1,0(A1,D0.L*8)	SET SHAPE TO D1	
	RTS
	DC.B	"SET_SPRI"
	EVEN	
**KILL_SPRITE NUMBER,D0
KILL_SPRITE:	MOVEM.L	D0-D3/A6,-(SP)
	LEA	SPRITE_VARS(PC),A6
	move.l	COOK_TAB_ADDR(A6),a0	*COOK TABLE ADDRESS
	move.l	back_mem(a6),a3
	MOVE.L	SHAPE_MEM(A6),a1	* graphic address
	LEA	SPRITE_DATA(PC),A2	*SPRITE DATA
	SUBQ.W	#1,D0
	BMI.S	OUT_OF_RANGE
	EXT.L	D0
	MOVE.L	D0,D7	COPY SPRITE NU,MBER
	LSL.L	#8,D0
	LSL.L	#2,D0	QUICK DIV BY 1024
	add.l	d0,a3	*point to background
	MOVE.L	D7,D6
	LSL.L	#2,D6	SPRITE NUM*4
	ADD.L	D6,A3	CORRECT FOR FIRST 2 WORDS BEING X/Y
	
	MOVE.W	0(A2,D7.L*8),D7	*GET SHAPE NUMBER
	EXT.L	D7
	LSL.L	#8,D7
	LSL.L	#2,D7
	ADD.L	D7,A1	*POINT TO RIGHT SHAPE
	
**check background isnt -1,-1

	move.w	(a3),d5
	bmi.S	no_backgroundK	first time

**MOVE OLD BACKGROUND
	MOVEM.L	D0-D1/A0-A3,-(SP)
	LEA	4(A3),A2	*BACKGROUND DATA
	MOVE.W	(A3),D0
	MOVE.W	2(A3),D1	OLD POSITION OF BACKGROUND	
	BSR	BG_PRINT	*REPLACE OLD BACKGROUND
	MOVEM.L	(SP)+,D0-D1/A0-A3
	MOVE.L	#-1,(A3)	RESET BACKGROUND
**GET NEW BACKGROUND
NO_BACKGROUNDK:	MOVEM.L	(SP)+,D0-D3/A6
	CLR.L	D0
	RTS
	DC.B	"KILL_SPR"
	EVEN


**do_sprites NEEDS A SPRITE LIST IN A0 - REPLACES THE BACKGROUNDS FOR THESE
*8SPRITES, LIST TERMINATED IN $FFFF
**SPRITE LIST LOOK LIKE:
**SPRITE ,X,Y, SPRITE,X,Y, SPRITE,X,Y, $FFFF
DO_SPRITES:	MOVEM.L	A5-A6,-(SP)
	MOVE.L	A0,-(SP)	SAVE LIST
	LEA	SPRITE_VARS(PC),A6
	MOVE.L	A0,A1	SPRITE LIST
	BSR	WAITFORSCREEN	WAIT FOR VBL

PB_LOOP:	MOVE.L	COOK_TAB_ADDR(A6),A0
	MOVE.L	BACK_MEM(A6),A3
	MOVE.W	(A1),D0	GET SPRITE NUMBER
	BMI.S	PB_END	IF -VE END OF LIST
	SUB.W	#1,D0	MAKE NUMBR 0->
	ADDQ.L	#6,A1	NEXT SPRITE (EACH SPRITE IS 6 WORDS)
**OLD PUT BACK ROUTINE
	EXT.L	D0	MAKE LONG
	MOVE.L	D0,D7
	LSL.L	#8,D0
	LSL.L	#2,D0	divide d0 by 1024	
	ADD.L	D0,A3	POINT TO BACKGROUND
	LEA	0(A3,D7.L*4),A3	ACCOUNT FOR BACKGROUND X,Y
**check background isnt -1,-1
	TST.w	(a3)	IF -1 THEN NO BACKGROUND TO COPY
	bmi.S	nb2	first time
**MOVE OLD BACKGROUND
	LEA	4(A3),A2	*BACKGROUND DATA
	MOVE.W	(A3),D0
	MOVE.W	2(A3),D1	OLD POSITION OF BACKGROUND	
	LEA	0(A0,D1.W*4),A0
	MOVEQ	#15,D2	*COUNTER/2-1 (32 lines)
PB_YLOOP2:	MOVE.L	(A0)+,A4
	ADD.W	(a3),A4	*RIGHT SCREEN ADDRESS
PB_YLOOP1:
	movem.l	(a2)+,d0-d1/d3-d7/a5	GET 8 LONGS
	movem.l	d0-d1/d3-d7/a5,(a4)	PUT 8 LONGS
	lea	32(a4),a4	point to next line
	move.l	(a0)+,a4	do next line
	add.w	(a3),a4
	movem.l	(a2)+,d0-d1/d3-d7/a5	GET 8 LONGS
	movem.l	d0-d1/d3-d7/a5,(a4)	PUT 8 LONGS (try that in C!)
	lea	32(a4),a4	point to next line

	DBRA	D2,PB_YLOOP2	DO NEXT 2 LINES
NB2:
	BRA.S	PB_LOOP	DO NEXT BACKGROUND
PB_END:	MOVE.L	(SP)+,A0	GET LIST
	BSR.S	PUT_SPRITES	NOW PRINT SPRITES
	MOVEM.L	(SP)+,A5-A6	POINT TO MAIN FILES VARS
	RTS		ASTA LA ....

************************************
**PUT_SPRITES
**checks back_mem(sprite) for coords of background.
**if coords then put pbackground.
**then gets background for new pos in back_mem
*8then draws sprite
**PUT SPRITES NEEDS A SPRITE LIST IN A0 - LOOKS LIKE
**SPRITE,X,Y, SPRITE,X,Y, SPRITE,X,Y,$FFFF

PUT_SPRITES:	MOVE.L	A0,-(SP)	SAVE LIST

PS2:	MOVE.W	(A0)+,D0	GET SPRITE NUMBER FROM LIST
	BMI.S	GB_END	-VE = END
	MOVE.W	(A0)+,D1	X
	MOVE.W	(A0)+,D2	Y
	MOVE.L	A0,a5
	BSR.S	GET_BG	GET BACKGROUNDS
	MOVE.L	a5,A0
	BRA.S	PS2	WHAT A CRAP LABEL!
	
GB_END:	MOVE.L	(SP)+,A0	GET LIST
PS1:	MOVE.W	(A0)+,D0	GET SPRITE NUMBER
	BMI.S	PS_END	-VE = END
	MOVE.W	(A0)+,D1	GET SPRITE X
	MOVE.W	(A0)+,D2	GET SPRITE Y
	MOVE.L	A0,a5
	BSR.S	PUT_SPRITE
	MOVE.L	a5,a0
	BRA.S	PS1
PS_END:	RTS

GET_BG:	move.l	COOK_TAB_ADDR(A6),a0	*COOK TABLE ADDRESS
	move.l	back_mem(a6),a3
	SUBQ.W	#1,D0
	EXT.L	D0
	MOVE.L	D0,D7	COPY SPRITE NU,MBER
	LSL.L	#8,D0
	LSL.L	#2,D0
	add.l	d0,a3	*point to background

	LSL.L	#2,D7	SPRITE NUM*4
	ADD.L	D7,A3	CORRECT FOR FIRST 2 WORDS BEING X/Y
	

**GET NEW BACKGROUND
	MOVE.W	D1,(A3)+	NEW BACKGROUND POS
	MOVE.W	D2,(A3)+
	MOVE.W	D1,D0	X IN D0, Y IN D1
	MOVE.W	D2,D1
	BSR.S	GET_BACKGROUND	COPY BACKGROUND
out_of_range1:	RTS
	DC.B	"GET_BG  "
	EVEN

**put_sprite is the sprite print routine
**it needs d0=sprite number, d1 = x coord and d2 = y coord

PUT_SPRITE:	move.l	COOK_TAB_ADDR(A6),a0	*COOK TABLE ADDRESS
	MOVE.L	SHAPE_MEM(A6),a1	* graphic address
	LEA	SPRITE_DATA(PC),A2	*SPRITE DATA
	SUBQ.W	#1,D0
	
	MOVE.W	0(A2,D0.W*8),D7	*GET SHAPE - D7*8 (4 FROM ABOVE)
	EXT.L	D7
	LSL.L	#8,D7
	LSL.L	#2,D7
	ADD.L	D7,A1	*POINT TO RIGHT SHAPE
	

	MOVE.W	D1,D0	X IN D0, Y IN D1
	MOVE.W	D2,D1

**PRINT SPRITE		
	LEA	0(A0,D1.W*4),A0
	ext.l	d0		* x position adjustment
	MOVEQ	#7,d2	* width one less
	MOVEQ	#31,d3	* height one less
		
NEXTLINE:
* next stage is to fetch the screen address
	move.l	(a0)+,a2
	add.l	d0,a2	* adjust the screen address by x position

	move.w	d2,d4	* make a duplicate of the width

NEXTACROSS:	TST.L	(A1)
	BEQ.S	SKIP_4
	MOVE.B	(A1)+,D1
	BEQ.S	SKIP1
	MOVE.B	D1,(A2)
SKIP1:	ADDQ.L	#1,A2
	MOVE.B	(A1)+,D1
	BEQ.S	SKIP2
	MOVE.B	D1,(A2)
SKIP2:	ADDQ.L	#1,A2
	MOVE.B	(A1)+,D1
	BEQ.S	SKIP3
	MOVE.B	D1,(A2)
SKIP3:	ADDQ.L	#1,A2
	MOVE.B	(A1)+,D1
	BEQ.S	SKIP4
	MOVE.B	D1,(A2)
SKIP4:	ADDQ.L	#1,A2
	dbra.w	d4,NEXTACROSS
	
	dbra.w	d3,NEXTLINE		* do until all the lines are drawn.
	RTS
	
SKIP_4:	ADDQ.L	#4,A1
	ADDQ.L	#4,A2
	DBRA	D4,NEXTACROSS
	DBRA	D3,NEXTLINE
PEND:	RTS

	RTS
	DC.B	"PUT_SPRI"
	EVEN
	
*********************SUBROUTINES***********************************************************
**NEEDS A0=COOK TABLE
**      A3=WHERE DATA IS TO GO
**      D0=X, D1=Y
**DESTROYS D1,D2/A0,A3,A4
GET_BACKGROUND:	MOVE.L	A4,D3	
	LEA	0(A0,D1.W*4),A0	ADJUST COOKTABLE TO FIND Y ADDRESS
	MOVEQ	#31,D2	*COUNTER
GB_YLOOP:	MOVE.L	(A0)+,A4
	ADD.L	D0,A4	*RIGHT SCREEN ADDRESS
*8COPY 8 LONGS (32 BYTES)
	MOVE.L	(A4)+,(A3)+
	MOVE.L	(A4)+,(A3)+
	MOVE.L	(A4)+,(A3)+
	MOVE.L	(A4)+,(A3)+
	MOVE.L	(A4)+,(A3)+
	MOVE.L	(A4)+,(A3)+
	MOVE.L	(A4)+,(A3)+
	MOVE.L	(A4)+,(A3)+
	DBRA	D2,GB_YLOOP
	MOVE.L	D3,A4
	RTS
	DC.B	"GET_BACK"
	EVEN
**NEEDS A0=COOK TABLE
**      A2=WHERE DATA IS COMING FROM
**      D0=X, D1=Y
**DESTROYS D1,D2/A0,A3,A4
BG_PRINT:	LEA	0(A0,D1.W*4),A0
	MOVEQ	#31,D2	*COUNTER
PB_YLOOP:	MOVE.L	(A0)+,A4
	ADD.W	(A3),A4	*RIGHT SCREEN ADDRESS
*8COPY 8 LONGS (32 BYTES)
	MOVE.L	(A2)+,(A4)+
	MOVE.L	(A2)+,(A4)+
	MOVE.L	(A2)+,(A4)+
	MOVE.L	(A2)+,(A4)+
	MOVE.L	(A2)+,(A4)+
	MOVE.L	(A2)+,(A4)+
	MOVE.L	(A2)+,(A4)+
	MOVE.L	(A2)+,(A4)+
	DBRA	D2,PB_YLOOP
	RTS
	DC.B	"PUT_BACK"
	EVEN
	
*****************************************************************************************

SPRITE_VARS:	DS.B	100	100 BYTES FOR OUR VARS
**SPRITE DATA:
**.W SHAPE, .W SPRITE X, .W SPRITE Y, .W SPARE :-)
SPRITE_DATA:	DS.B	MAX_SPRITES*8
SPRITE_BUFFER:	DS.B	1026	TEMPORY FOR SHAPE LOAD
	RSRESET
SCRN_BASE_ADDR:	RS.L	1	ADDRESS OF BASE OF SCREEN VRAM
SHAPE_MEM:	RS.L	1	ADDRESS OF MEMORY BLOCK
SHAPE_MEM_SIZE:	RS.L	1	SIZE OF MEMORY BLOCK
BACK_MEM:	RS.L	1	ADRESS OF BACKGROUND MEMORY
BACK_MEM_SIZE:	RS.L	1	SIZE OF BACKGROUND MEMORY
PICT_HANDLE:	RS.L	1	LOADED ICL8 HANDLE
COOK_TAB_ADDR:	RS.L	1	INTERNAL COOK TABLE ADDRESS
MAX_X:	RS.W	1
MAX_Y:	RS.W	1
SPRITES_LOADED:	RS.W	1	NUMBER OF SPRITES LAODED
SCRATCH_1:	RS.L	1	SAVE SPRITE NUMBER IN LOADER
*****************************************************************************************