* Wait for Screen Utility
*
* Written by Rob (Zed) Probin 
* Copyright Lightsoft 1994


*
* IMPORTANT NOTES ON THIS CODE.
*
* i) This code uses the slot vbl routines. Briefly, the original VInstall and 
*    VRemove are kept for basically compatibility reasons only, for general purpose
*    timers. This change in the AppleOS was needed because of the need to support
*    multiple screen displays. Each screen display has its own slot. Hence to install
*    a VBL routine one must tell the OS (operating system) which slot to install it in.
*    The calls (when a routine wishes to syncronise with the screen display start) are
*    SlotVInstall and SlotVRemove.
*
* ii) This code ASSUMES THE SLOT NUMBER OF THE MAIN SCREEN IS ZERO. This is NOT
*     good programming, and is liable to fall down. The normal sequence of events
*     for a well behaved program is: (a) decide whether this machine has slot based
*     vbl routines (does the trap exist?), (b) find the slot number by accessing
*     the main graphics device's reference number, and casting the device control
*     entry to type AuxDCEHandle, and access the slot number directly.
*
*
* For more information see the chapter entilied 'Vertical Retrace Manager' within
* the volume 'Inside Macintosh:Processes' by Apple Computer Inc.
*

	INCLUDE	vbl_header.s		* this contains equates and macros.


* How To install me
*
Install_WaitForScreenVBL:
		lea	qWait4Scrn(pc),a0
		lea	WaitForScreenVBL(pc),a1
		InstallVBL 	a1,#1,#0

* purposely ignore error....
		rts
		
Remove_WaitForScreenVBL:
		lea	qWait4Scrn(pc),a0
		RemoveVBL
		rts
		
* THE INTERESTING COMMAND
*
WaitForScreen:
		move.w	cntWait4Scrn(pc),d0
WaitForScreen_Loop:
		cmp.w	cntWait4Scrn(pc),d0
		beq.s	WaitForScreen_Loop
		rts
		
* THE VBL DRIVER ROUTINE
*
WaitForScreenVBL:
		VBLAgain 	#1	* do it straight away
		lea	cntWait4Scrn(pc),a1
		addq.w 	#1,(a1)
		rts
		
		even
		
* The data
*
cntWait4Scrn:
		ds.w	1
qWait4Scrn:
		ds.b	14
		
		even