* VBL ROUTINE TRAPS
*
* Written by Rob (Zed) Probin 
* Copyright Lightsoft 1994

_VInstall		EQU	$A033		* for the olde type vbl
_VRemove		EQU	$A034
_SlotVInstall	EQU	$A06F		* for external grafix device type vbl
_SlotVRemove	EQU	$A070

* VBLTask type record/structure
	rsreset
qLink:	rs.l	1	* next entry in vertical retrace queue
qType:	rs.w	1	* queue type
vblAddr:	rs.l	1	* pointer to task procedure
vblCount:	rs.w	1	* interrupts until next exeception
vblPhase:	rs.w	1	* task phase

vType		EQU	1			* VBL queue element type
inVBL		EQU	6			* bit index for vbl active flag

* IN: 	A0 	-> pointer to myVBLQueue (data space (10bytes) to store queue at)
*     	1st param 	-> pointer to myVBLtask (address of routine that is a vbl)
*	  2nd param 	-> freq of vbl task (0=never, 1=next vbl)
*	  3rd param 	-> phase of vbl task (usually 0)
*
* OUT:			D0	-> Result code
*
InstallVBL:	MACRO
			move.w	#vType,qType(a0)		* set the queue type
			move.l	\1,vblAddr(a0)		* and where to call
			move.w	\2,vblCount(a0)		* and when its going to be called next
			move.w	\3,vblPhase(a0)		* and any phase
			moveq	#0,d0
			dc.w	_SlotVInstall
			ENDM

* IN:			A0 -> pointer to myVBLQueue
*
* OUT:			D0 -> Result code
*
RemoveVBL:	MACRO
			moveq	#0,d0
			dc.w	_SlotVRemove
			ENDM
			
* IN:			A0 	-> Address of VBL task record from vbl manager
*		1st param	-> number of cycles before its called again
* NOTES:		This should be called early in the vbl routine, so that a0 is not destroyed
VBLAgain:	MACRO
			move.w	\1,vblCount(a0)
			ENDM
			
	

